/////////////
//  mid.js //
///////////// 
//
// Acknowledgement:
//
// This code contains parts of other extensions such as iconifyTabs, duplicateTab
// Flowing tabs, miniT, and so one. Many thanks for their authors. 
//
//
const Cc = Components.classes;
const Ci = Components.interfaces;

// findService = Cc["@mozilla.org/find/find_service;1"].getService(Ci.nsIFindService);

/*   window. "global"  vars  */

locale = "us"; 
dictionary="default";
progresscounter=0;
midForwardCounter=0;
midBackCounter=-1;
midSaveInTree=true;
midRowCounter=-1;
midFullScreen=false;
midFromRestore=false;
tabIconic=false;
throbberDisabled=false;
isRunning=false;
homepage="about:blank";
midBrowserStartLocation="http://www.google.com";
midNS="http://mid.mozdev.org/dictionaries";
preventFocusReset=false;

midMyPrefB = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);
midMyPrefS = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);

/* main */



function midmain(e)
{
    if (isRunning) return;  // called from urlbar as chrome://mid/content
    isRunning=true;

    domHelper = new domHelperObject; // global

//    addEventListener("focus",checkFocusedElement,true);
//    addEventListener("click",checkClickedElement,true);
//    addEventListener("keyup",checkKeypressElement,false);
    
    managePreferences(); 

    managePreferences(); 
    setBrowserURL();
    
    dictionary="default";
    restoreDefaultSet(); 

    window.addEventListener("load",midMyOnLoad,true);
};


function domHelperObject()
{

	this.tabpanelsElement = document.getElementById("mid_tabpanels");
	this.tabsElement      = document.getElementById("mid_tabs");

};   


function focusSearchField()
{
   // myDump("fffffff");
   s=document.getElementById("mid_searchWord").focus();
   // felejtsd el var list=document.getAnonymousNodes(s);
   // --"--       var element=list.item(0).firstChild.focus();  // if u know better tell me ...
 
   preventFocusReset=false;
}



function checkFocusedElement(event)
{
myDump("******"); myDump("before if");
  
    if (preventFocusReset) return;
  
    if (event.target.tagName!="textbox")
       document.getElementById("mid_Url").value=event.target.tagName;

  if (document && document.commandDispatcher && document.commandDispatcher.focusedElement){
        myDump(document.commandDispatcher.focusedElement.tagName);
  }

if (event.originalTarget && event.originalTarget.tagName){
         myDump("in if1");
         myDump(event.originalTarget.tagName);
         myDump(event.target.tagName);
        // myDump(document.commandDispatcher.focusedElement);
	var name=event.originalTarget.tagName;
	myDump("name:"+name);
        if (name=="INPUT" || name=="LABEL" || name=="TEXTAREA" || name=="BUTTON" || 
	    !name ) {
            event.stopPropagation();
           //event.preventDefault();
           setTimeout('focusSearchField()',20);
        }
    } else { 
    event.stopPropagation();
    setTimeout('focusSearchField()',20);
    }
} 


function checkClickedElement(event)
{
   preventFocusReset=true;
   setTimeout('event.originalTarget.focus()',20);

   myDump("***click***");
   myDump("target"+event.target.tagName);
   myDump("current" + event.currentTarget.tagName);
   myDump("orig"+event.originalTarget.tagName);
}


function checkKeypressElement(event)
{
    myDump("+++keyup+++");
    preventFocusReset=true;
    if (event.originalTarget.tagName && (event.originalTarget.tagName=="html:input")) {
        preventFocusReset=false;
    }
    if (event.originalTarget.tagName && (event.originalTarget.tagName=="tab")) {
          preventFocusReset=true;
    }
    myDump(event.originalTarget.tagName);
    myDump(preventFocusReset);
}




var midWebProgressListener =
  {
    QueryInterface: function(iid) {
    if (iid.equals(Ci.nsIWebProgressListener) ||
        iid.equals(Ci.nsISupportsWeakReference) ||
        iid.equals(Ci.nsISupports))
      return this;
    
     throw Components.results.NS_ERROR_NO_INTERFACE;
  },

    onProgressChange : function (wp, req, cur, max, curtotal, maxtotal) {},
    onStateChange : function (wp, req, state, status) {
      if ((state & Ci.nsIWebProgressListener.STATE_STOP ) && 
	 (state & Ci.nsIWebProgressListener.STATE_IS_NETWORK)){
	 // alert(wp.DOMWindow.document.location.href);
	 if (progresscounter>0) progresscounter=progresscounter-1;
         if (progresscounter==0) 
	   document.getElementById("mid_stoploadbutton").disabled=true;
	 if (!throbberDisabled) setTimeout(setThrobber,0,wp.DOMWindow,false);
      } 
      if ((state & Ci.nsIWebProgressListener.STATE_START ) && 
	 (state & Ci.nsIWebProgressListener.STATE_IS_NETWORK)){
         document.getElementById("mid_stoploadbutton").disabled=false;
	 progresscounter=progresscounter+1;
	 if (!throbberDisabled) setTimeout(setThrobber,0,wp.DOMWindow,true);
      }
      if ((state & Ci.nsIWebProgressListener.STATE_TRANSFERRING)){
	 if (!throbberDisabled) setTimeout(setThrobber,0,wp.DOMWindow,false);
	 }
    },
    onLocationChange : function (wp, req, loc) {},
    onStatusChange : function (wp, req, status, message) {},
    onSecurityChange : function (wp, req, state) {}
  };



function setThrobber (dm,image)
{
    var doc=dm;
    var mytabs = domHelper.tabsElement; 
    var tabs=mytabs.getElementsByTagName("tab");
    var mytabpanels = domHelper.tabpanelsElement;
    var iTab;
    for (i=0;(iBrowser=mytabpanels.getElementsByTagName("browser").item(i));i++){
       iTab=tabs.item(i);
       if ( iBrowser.currentURI && iBrowser.currentURI.spec==doc.document.location.href){
           if ( image ) {
              iTab.setAttribute("busy","true");
	      iTab.removeAttribute("image");
	   }
	   else { 
	      if (iTab.hasAttribute("busy")){
    	          iTab.removeAttribute("busy");
	          iTab.setAttribute("image",iBrowser.xmlDic.getAttribute("fav"));
	      }
	   }

        }
    }
	  
}



function  managePreferences()
{

    /* get rid of old-style preferences */
    if (midMyPrefB.getPrefType("extensions.mid.dtype.en_en") == midMyPrefB.PREF_BOOL){
        branch = midMyPrefS.getBranch("extensions.mid.dtype.");
        branch.deleteBranch("");
     }

    /* First run, set factory default */

    var deftype=
    document.getElementsByTagNameNS(midNS,"default-dict-type").item(0).getAttribute("label");
    if (midMyPrefB.getPrefType("extensions.mid.dtype."+ deftype) != midMyPrefB.PREF_BOOL){
        midMyPrefB.setBoolPref("extensions.mid.dtype." + deftype, true) ;
	myDump(deftype);
    }

    /* manage layout */

    if (midMyPrefB.getPrefType("extensions.mid.layout.browserup")==midMyPrefB.PREF_BOOL){
        if (midMyPrefB.getBoolPref("extensions.mid.layout.browserup")) {
	    var t=document.getElementById("mid_tabbox");
	    var s=document.getElementById("mid_BrowserSplitter");
	    var b=document.getElementById("mid_BrowserBox");
            var p=b.parentNode;
	    p.removeChild(b);
	    p.removeChild(t);
	    p.insertBefore(b,s);
	    p.appendChild(t);
	};

    };

    /* get throbber setting */

    if (midMyPrefB.getPrefType("extensions.mid.disable.throbber")==midMyPrefB.PREF_BOOL){
        if (midMyPrefB.getBoolPref("extensions.mid.disable.throbber")) {
	   throbberDisabled=true;
        }
    }

} 



function  setBrowserURL(){

    /* Started from a browser */
    if (window.opener && window.opener.content.location.href != ""){
        midBrowserStartLocation=window.opener.content.location.href; 
        document.getElementById("mid_MainBrowser").setAttribute(
	                        "src",midBrowserStartLocation);
	document.getElementById("mid_Url").value=midBrowserStartLocation;
    }

}



function midMyOnLoad(e)
{

//	e.stopPropagation();

}



function loadDictionaries(midlines)
{
   var i,xmlDic, dictType, dictChecked;
    
    ITomb = new Array();
    DTomb = new Array();

    dictionary="default" ; 
    /* clear tabpanels */

    var tps=domHelper.tabpanelsElement;
    while (tps.hasChildNodes()) {
        try {
	    tps.firstChild.removeProgressListener(midWebProgressListener);
        } catch(e) { alert ("removeProgressListener failed") ; } ;
      tps.removeChild(tps.firstChild);
    }

    /* clear tabs */

    var mytabs=domHelper.tabsElement;
    while (mytabs.hasChildNodes()) mytabs.removeChild(mytabs.firstChild);

    for(i=0; (xmlDic=document.getElementsByTagNameNS(midNS,"dict").item(i));i++)
    {
        dictId      = xmlDic.getAttribute("dictid");
        dictType    = xmlDic.getAttribute("type");
        if (midlines) {
            dictionary="temporary" ; 
            if (midlines.join().indexOf(dictId)>-1) {
                DTomb.push(midlines.join().indexOf(dictId)/37);
                ITomb[midlines.join().indexOf(dictId)/37]=i;
                dictChecked=false;
            }  else dictChecked=false;
        }
        else {
        if  ( xmlDic.getAttribute("checked") == "true" ) dictChecked=true ; else dictChecked=false  ;
        if (midMyPrefB.getPrefType("extensions.mid."+ dictId + "_checked" ) == midMyPrefB.PREF_BOOL){
           dictChecked = midMyPrefB.getBoolPref("extensions.mid."+ dictId + "_checked" ) ;
        }
        dtchecked = false;
        if (midMyPrefB.getPrefType("extensions.mid.dtype."+ dictType) == midMyPrefB.PREF_BOOL){
            dtchecked = midMyPrefB.getBoolPref("extensions.mid.dtype." + dictType) ;
        }

        if ( dtchecked )  {
            createDictionaryTab(xmlDic,dictChecked);
         } /* if checked type */
       }
    } // for

    if (midlines)
        for (var k in DTomb ) {
            xmlDic=document.getElementsByTagNameNS(midNS,"dict").item(ITomb[k]);
            dictId      = xmlDic.getAttribute("dictid");
            dictType    = xmlDic.getAttribute("type");
            dictChecked = true;
            dtchecked   = true;
            createDictionaryTab(xmlDic,dictChecked);
        }

     DTomb=null;
     ITomb=null;

     /* Add progress listeners and find first not collapsed */

     var selecteditem=0; 
     var myBrowser;

     for (i=tps.getElementsByTagName("browser").length-1;
           ( myBrowser = tps.getElementsByTagName("browser").item(i) );
	   i--
	 ) {
           myBrowser.docShell.allowJavascript=true;
           if (myBrowser.xmlDic.getAttribute("js")=="disabled") { 
               myBrowser.docShell.allowJavascript=false;
           }
           selecteditem=i;
           try {
	       myBrowser.addProgressListener( midWebProgressListener,
		                          Ci.nsIWebProgress.NOTIFY_STATE_NETWORK );
	   } catch(e) { alert ("addProgressListener failed") ; } ;
     }
     mytabs.selectedIndex=selecteditem;

} 



function createDictionaryTab(xmlDic,dictChecked) {

    if (!dictChecked) return; // old thing, collapsed  browser
    var   newTab, newBrowser;

    newTab=document.createElement("tab");
    newTab.setAttribute("id","tab"+ dictId );
    newTab.setAttribute("context","mid_tabcontextpopup");
    newTab.setAttribute("label",xmlDic.getAttribute("label") );
    /* image on tab */
    newTab.setAttribute("image",xmlDic.getAttribute("fav"));
    newTab.setAttribute("tooltiptext", xmlDic.getAttribute("label") + " : " 
	  + xmlDic.getAttribute("home") );
    newTab.setAttribute("dicthome",xmlDic.getAttribute("home"));
	 
    newTab.setAttribute("iconic", tabIconic ? "true" : "false" ); 
    domHelper.tabsElement.appendChild(newTab);

    newBrowser    = document.createElement("browser");
    newBrowser.xmlDic = xmlDic;
    newBrowser.setAttribute("onload","event.stopPropagation();");
    newBrowser.setAttribute("id","b"+ dictId );
    newBrowser.setAttribute("type","content-primary");
    newBrowser.setAttribute("context","mid_browsercontextpopup");
    newBrowser.setAttribute("src",xmlDic.getAttribute("home"));
    newBrowser.setAttribute("homepage",xmlDic.getAttribute("home"));
    newBrowser.setAttribute("ondblclick","contextLookup()");

    domHelper.tabpanelsElement.appendChild(newBrowser);

}; /* function createDictionaryTab */



function getDictionaryPreferences() {

    var midDictArg = new Object;
    
    openDialog("choose_dict.xul","pref",
           "modal=1,dialog=1,chrome=1,centerscreen=1,resizable=0",
		    midDictArg );
    if (midDictArg.mylines) {
        midlines=midDictArg.mylines; delete midDictArg ;
        loadDictionaries(midlines);

    } else if (midDictArg.result) {
        delete midDictArg;
        loadDictionaries();
        saveDefaultSet();
    }

    delete midDictArg ;

}



function wordsTreePopupShowing(event)
{

    midRowCounter=-1; // global

    var str_OrigTarget = document.popupNode;
    if (str_OrigTarget.localName == "treechildren")
    {
        var obj_Row = new Object;
        var obj_Col = new Object;
        var obj_Child = new Object;
        var obj_Tree = document.getElementById("mid_wordstree");
        obj_Tree.treeBoxObject.getCellAt(event.clientX, event.clientY, obj_Row, obj_Col, obj_Child);
        midRowCounter=obj_Row.value ;
    }

   document.getElementById('mid_treecontextpopup').setAttribute("collapsed","false");
   if (midRowCounter<0) {
   document.getElementById('mid_treecontextpopup').setAttribute("collapsed","true")
   } 

}



function getTreeRow(event)
{

    midRowCounter=-1;  // global

    if (event.detail==2) {
       var str_OrigTarget = event.originalTarget;
    } else { 
       var str_OrigTarget = document.popupNode;
    }
    if (str_OrigTarget.localName == "treechildren")
    {
      var obj_Row = new Object;
      var obj_Col = new Object;
      var obj_Child = new Object;
      var obj_Tree = document.getElementById("mid_wordstree");
      obj_Tree.treeBoxObject.getCellAt(event.clientX, event.clientY, obj_Row, obj_Col, obj_Child);
      midRowCounter=obj_Row.value ;
   }   
   
   return midRowCounter;
 
}



function wordsTreeLookup(event)
{ 

    var word=document.getElementsByTagName("treecell").item(midRowCounter*2);
    document.getElementById("mid_searchWord").value=word.getAttribute("label");

    midSaveInTree=false;
    lookupWord();

    midSaveInTree=true;

}



function wordsTreeFillDefinition(event)
{ 
     // midRowCounter is known from popupshowing
     var defi=document.getElementsByTagName("treecell").item(midRowCounter*2+1);

     var defstrbundle=document.getElementById("tree.definition");
     var definition=defstrbundle.getString("tree.definition");

     defi.setAttribute("label",prompt(definition,defi.getAttribute("label")));

}



function wordsTreeRemoveRow(event)
{

    wordsTree=document.getElementById("mid_wordstree");
    myoldrowcount=wordsTree.view.rowCount;
    myrow = document.getElementsByTagName("treecell").item(midRowCounter*2+1);
    myrow.parentNode.removeChild(myrow);
    myrow = document.getElementsByTagName("treecell").item(midRowCounter*2);
    myrow = document.getElementsByTagName("treerow").item(midRowCounter);
    parent=myrow.parentNode;
    parent.removeChild(myrow);
    parent.parentNode.removeChild(parent);
    
   // if (!( midBackCounter < myrow) ) midBackCounter-- ; 
   // else midForwardCounter--; 

}



function wordsTreeRemoveAllRow(event)
{

    var wordsTree=document.getElementById("mid_wordstreechildren");
    while (wordsTree.hasChildNodes()) wordsTree.removeChild(wordsTree.firstChild)

}



function setValue(event)
{

    var tree = document.getElementById("mid_wordstree");
    var tbo = tree.treeBoxObject;
    var row = { }, col = { }, child = { };
    tbo.getCellAt(event.clientX, event.clientY, row, col, child);
  
    if ( col.value.id!="mid_words" ) return; // editing definition

    var word=document.getElementsByTagName("treecell").item(getTreeRow(event)*2);
    document.getElementById("mid_searchWord").value=word.getAttribute("label");

    midSaveInTree=false;
    lookupWord();

    midSaveInTree=true;

}



function mainBrowserPopupShowing()
{

    if (getSelectionForLookup()==''){
       document.getElementById("mid_mainBCL").setAttribute("disabled","true");
       document.getElementById("mid_mainBCC").setAttribute("disabled","true");
    } else {
    document.getElementById("mid_mainBCL").setAttribute("disabled","false");
    document.getElementById("mid_mainBCC").setAttribute("disabled","false");
    }

    var mid_mb=document.getElementById("mid_MainBrowser");
    
    if (mid_mb.canGoBack==false){
        document.getElementById("mid_mainBCB").setAttribute("disabled","true");
    } else { 
        document.getElementById("mid_mainBCB").setAttribute("disabled","false");
    }

    if (mid_mb.canGoForward==false){
       document.getElementById("mid_mainBCF").setAttribute("disabled","true");
    } else { 
       document.getElementById("mid_mainBCF").setAttribute("disabled","false");
    }

}



function dictBrowserPopupShowing(event)
{

    if (getSelectionForLookup()==''){
        document.getElementById("mid_BCL").setAttribute("disabled","true");
        document.getElementById("mid_BCC").setAttribute("disabled","true");
    } else {
       document.getElementById("mid_BCL").setAttribute("disabled","false");
       document.getElementById("mid_BCC").setAttribute("disabled","false");
    }

    var myTabPanel=domHelper.tabpanelsElement;

    if (myTabPanel.selectedPanel.canGoBack==false){
        document.getElementById("mid_BCB").setAttribute("disabled","true");
    } else { 
        document.getElementById("mid_BCB").setAttribute("disabled","false");
    }

    if (myTabPanel.selectedPanel.canGoForward==false){
        document.getElementById("mid_BCF").setAttribute("disabled","true");
    } else { 
        document.getElementById("mid_BCF").setAttribute("disabled","false");
    }

}



function contextLookup()
{

    document.getElementById("mid_searchWord").value=getSelectionForLookup();
    lookupWord(); 

}



function getSelectionForLookup()
{

    var selection = "";
        if (selection!="") return selection;
    
    var focusedWindow = document.commandDispatcher.focusedWindow;
    selection = focusedWindow.getSelection();
   
    if (selection!="") return selection; 

    if (document.popupNode) {
        var nodeLocalName = document.popupNode.localName.toUpperCase();
        if ((nodeLocalName == "TEXTAREA") ||
           (nodeLocalName == "INPUT" && node.type == "text")) {
           selection = node.value.substring(node.selectionStart,node.selectionEnd);
        }
     }
     return selection;

}



function midCopyText()
{

   const gClipboardHelper =
   Cc["@mozilla.org/widget/clipboardhelper;1"].getService(Ci.nsIClipboardHelper);
   gClipboardHelper.copyString(getSelectionForLookup());

}



function dictTabPopupShowing()
{
   // alert(document.popupNode.id);
}



function midCloseTab()
{

    var dictTabPanels = domHelper.tabpanelsElement;
    var dictTabs      = domHelper.tabsElement;
    var dictTabId     = document.popupNode.id;
    var dictBrowserId = dictTabId.replace("tab","b");
 
   
    var dictTabToRemove     = document.getElementById(dictTabId);
    var dictBrowserToRemove = document.getElementById(dictBrowserId);

    if (dictTabToRemove.getAttribute("selected","true")) {
       dictTabs.advanceSelectedTab(1,true);
    };

    try{
      dictBrowserToRemove.removeProgressListener(midWebProgressListener);
    } catch(e) {};
    
    dictTabPanels.removeChild(dictBrowserToRemove);
    dictTabs.removeChild(dictTabToRemove);

    dictTabPanels.selectedIndex=dictTabs.selectedIndex;
    var dictId = dictTabId.replace ("tab", "");
    midMyPrefB.setBoolPref("extensions.mid." + dictId + "_checked", false) ;

    // dictBrowserToRemove = null;
    // dictTabToRemove = null;

}



function midOpenHomePage()
{
    var dictTab=document.getElementById(document.popupNode.id);
    window.open(dictTab.getAttribute("dicthome"));
}



function convertLookupWord(b,w) {

    var cw="";
    var converter = Cc['@mozilla.org/intl/texttosuburi;1']
   		   .createInstance(Ci.nsITextToSubURI);
	
    try  {
          cw=converter.ConvertAndEscape(b.contentDocument.characterSet,w);
	 } catch (e) { cw=w }

    return cw; 

};



function lookupWord()
{

    var i, url, smyWord, myBrowser;
    var myWord =document.getElementById("mid_searchWord").value; 
   
//   myWord=myWord.replace(/[\-,'"+!%\/=(),.?:_]*$/g,"");
    myWord=myWord.replace(/['"+!%\\\/=\(\)\[\]\{\},\.\-?:_ <>]*$/g,"");

    if (myWord=='') {return 0 ;}
    document.getElementById("mid_searchWord").value=myWord; 
    // var wordsTreeChildren = document.getElementById("mid_wordstreechildren");
   
    for(i=0; (myBrowser=document.getElementsByTagName("browser").item(i));i++)
    { 
        if ( myBrowser.getAttribute("id") != "mid_MainBrowser"){
	   smyWord = convertLookupWord(myBrowser,myWord);
           if ( myBrowser.xmlDic.getAttribute("method") == "POST"){
	       midPostURI(myBrowser,smyWord); 
           } else  if (myBrowser.xmlDic.getAttribute("method")=="func"){
	        searchfunction=myBrowser.xmlDic.getAttribute("function_name");
	        try {
	            eval(searchfunction)(myBrowser,myWord,smyWord);
	        } catch (e) {alert ("Function error:"+searchfunction);}; 
	   } else {
	       url = myBrowser.xmlDic.getAttribute("url");
	       myBrowser.setAttribute("src", url.replace("XXX",smyWord));
	   }; // normal
	   //findService.searchString = myWord;    
           // findService.findNext();
        }; // if
    };     // for
   
    // document.commandDispatcher.focusedWindow.find(myWord);

    document.getElementById("mid_searchWord").focus();
    document.getElementById("mid_searchWord").
        setSelectionRange(0,document.getElementById("mid_searchWord").textLength);

    midBackCounter++; 
    midupdateImages();

    // don't save it twice in the tree
    var wordsTree=document.getElementById("mid_wordstree");  
    var wordsTreeRow=wordsTree.view.rowCount;         
    if ( wordsTreeRow > 0 ) {
        // Compatibility issues(getcelltext)?
        var col = wordsTree.columns ? wordsTree.columns["mid_words"] : "mid_words";
        try {
          wordsTreeCellText = wordsTree.view.getCellText(wordsTreeRow-1, col  ); 
        } catch (e) {alert(e);}
        if (wordsTreeCellText==myWord) return ; // same as the last word
    }
 
    if (! midSaveInTree ) {return};
    saveInHistory(myWord,"");
   
}



function saveInHistory(myWord,myDef)
{

    var wordsTreeChildren = document.getElementById("mid_wordstreechildren");
    var wordsTree=document.getElementById("mid_wordstree");
    var wordsTreeRow=wordsTree.view.rowCount;

    var newTreeItem = document.createElement("treeitem");
    var newTreeRow = document.createElement("treerow");
    var newWord = document.createElement("treecell");
    var newDef = document.createElement("treecell");
   
    newWord.setAttribute("label",myWord);
    newWord.setAttribute("editable","false");
    newTreeRow.appendChild(newWord);
    newDef.setAttribute("label",myDef);
    newTreeRow.appendChild(newDef);
   
    newTreeItem.appendChild(newTreeRow);
    wordsTreeChildren.appendChild(newTreeItem);
   
    wordsTree.treeBoxObject.ensureRowIsVisible(wordsTreeRow);

}



function midaboutBox()
{

    openDialog("about.xul",
       	"About mid",
	"chrome,resizeable,centerscreen,dialog,min-width=350px");

};



function showHomePage()
{

    window.open("http://mid.mozdev.org");

}



function showAllDictionaries()
{

    var myff = Cc["@mozilla.org/file/directory_service;1"]
        .getService(Ci.nsIProperties)
        .get("ProfD", Ci.nsIFile);

    var ios = Cc["@mozilla.org/network/io-service;1"]
        .getService(Ci.nsIIOService);

    var fileHandler = ios.getProtocolHandler("file")
        .QueryInterface(Ci.nsIFileProtocolHandler);

    var URL = fileHandler.getURLSpecFromFile(myff);

    var fURL= "jar:" +URL +
        "/extensions/{9ef1e09b-d4b2-4a55-ac3e-1cb330546bec}" +
        "/chrome/mid.jar!/content/dictionaries.xml";

    var mURL= "jar:" +URL +
        "/chrome/mid.jar!/content/dictionaries.xml";

    var midBWrapper = new Object;

    midBWrapper.Firefox   = function () { window.open(fURL); };
    midBWrapper.Flock     = function () { window.open(fURL); };
    midBWrapper.Netscape  = function () { window.open(fURL); };
    midBWrapper.SeaMonkey = function () { window.open(mURL); };
    midBWrapper.mid       = function ()
    	{
            var myff = Cc["@mozilla.org/file/directory_service;1"]
       	        .getService(Ci.nsIProperties)
       	        .get("resource:app", Ci.nsIFile);
            var URL = fileHandler.getURLSpecFromFile(myff);
            var xURL= URL + "chrome/content/mid/dictionaries.xml";
            window.open(xURL);
        };
 	
    midBrowserWrapper( midBWrapper );
    
}



function midBrowserWrapper(a){

	var midBrowserName = ""; 

	try {
	    var appInfo = Cc["@mozilla.org/xre/app-info;1"]
              .getService(Ci.nsIXULAppInfo);
	} catch(e) {};

	if ( appInfo ) midBrowserName = appInfo.name ;
        //	alert(midBrowserName);
	switch ( midBrowserName) {
		case "Firefox":		a.Firefox(); break;
		case "Browser":	 	a.Flock(); break; 	// Flock now
		case "Flock":	 	a.Flock(); break; 	// Flock later?
		case "Netscape":	a.Netscape(); break;
		case "SeaMonkey":	a.SeaMonkey(); break;
		case "mid":             a.mid(); break; 	// Xulrunner aka
		default: 	        alert("Sorry, unkown or old browser");
	};

}



function middoSerialize()
{
// this function is not used, as the time being
    var nsIFilePicker = Ci.nsIFilePicker;
    var nsIFileChannel = Ci.nsIFileChannel;
   
    var file = null, fileStream=null;
   
    var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
    fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modeSave);
    fp.appendFilters(nsIFilePicker.filterAll);
    if (fp.show() != nsIFilePicker.returnOK) { return false;}
      file = fp.file;
    fileStream =
    Cc["@mozilla.org/network/file-output-stream;1"].createInstance
    (Ci.nsIFileOutputStream);
    var wordsTree = document.getElementById("mid_wordstree");
    var serializer = new XMLSerializer();
    var treestr = serializer.serializeToString("mid_wordstree");
   
    fileStream.init( file, 0x04 | 0x08, 420, 0 );
    serializer.serializeToStream(wordsTree,fileStream,null);
    localAlert("file.saved",""); 
};



function middoSave()
{

    var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
              createInstance(Ci.nsIScriptableUnicodeConverter);
    conv.charset = "UTF-8";

    var nsIFilePicker = Ci.nsIFilePicker;
    var nsIFileChannel = Ci.nsIFileChannel;
    var file = null, fileStream=null; 
   
    var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
    fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modeSave);
    fp.appendFilters(nsIFilePicker.filterAll);
    if (fp.show() == nsIFilePicker.returnCancel) { return false;}
        file = fp.file;

    fileStream = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
    var wordsTree = document.getElementById("mid_wordstree");

    try {   
        fileStream.init( file, 0x04 | 0x08| 0x20, 420, 0 );
    } catch(e) {
        if ( e.name == "NS_ERROR_FILE_ACCESS_DENIED" ) localAlert("file.access.denied","");
        else alert("i/o error: " + e.name + "-" + e.message);   
    } 
  

    var i,a1,a2,word,def;
   
    for(i=0; (a1=document.getElementsByTagName("treecell").item(i));i=i+2){

       word=a1.getAttribute("label");
       // var myTabPanel=domHelper.tabpanelsElement;
       // myTabPanel.selectedPanel.goBack();
       a2=document.getElementsByTagName("treecell").item(i+1);
       def=a2.getAttribute("label");
       data =conv.ConvertFromUnicode( word + ";" + def + "\n")   
       fileStream.write(data, data.length);
      
    };
   
    fileStream.close();
    localAlert("file.saved",""); 
};



function middoRead()
{
    var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
		createInstance(Ci.nsIScriptableUnicodeConverter);
    conv.charset = "UTF-8"

    var nsIFilePicker = Ci.nsIFilePicker;
    var nsIFileChannel = Ci.nsIFileChannel;
   
    var file = null, fileStream=null, sorstr="" ; 
    var sor = new Array;

    var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
    fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modOpen);
    fp.appendFilters(nsIFilePicker.filterAll);
    if (fp.show() == nsIFilePicker.returnCancel) { return false;}
    file = fp.file;


    var istream = Cc["@mozilla.org/network/file-input-stream;1"]
		.createInstance(Ci.nsIFileInputStream);
    try {	
	istream.init(file, 0x01, 0444, 0);
    } catch(e) {
        if ( e.name == "NS_ERROR_FILE_ACCESS_DENIED" ) localAlert("file.access.denied","");
        else alert("i/o error: " + e.name + "-" + e.message);
    }

    istream.QueryInterface(Ci.nsILineInputStream);

    /* read lines into array */
    var line = {}, lines = [], hasmore;
    do {
        hasmore = istream.readLine(line);
        sorstr=conv.ConvertToUnicode(line.value)
        sor[0]=""; sor[1]="";
        sor = sorstr.split(";");
        saveInHistory ( sor[0], sor[1]); 
        lines.push(line.value); 
    } while(hasmore);

    istream.close();
};



function midallBrowsersStop()
{

    var myBrowser;
    const nsIWebNavigation = Ci.nsIWebNavigation;
    const flags = nsIWebNavigation.STOP_ALL;
  
    for (i=0; (myBrowser=document.getElementsByTagName("browser").item(i));i++){
     	try {
             if (myBrowser.getAttribute("id")!="mid_MainBrowser")
	        { myBrowser.webNavigation.stop(flags) } ;
        } catch (e) { alert ( myBrowser.getAttribute("homepage") ) ;}   
    } 

}



function midhistForward()
{

    var myBrowser;
    if ( midForwardCounter >0 ){
  
    for (i=0; (myBrowser=document.getElementsByTagName("browser").item(i));i++) {
        try {
            if (myBrowser.getAttribute("id")!="mid_MainBrowser") {
	        if (myBrowser.xmlDic.getAttribute("method")=="POST") {
	            if (!( midForwardCounter < 0)) {
	                 word = document.getElementsByTagName("treecell").item((midBackCounter+1)*2);
                         midPostURI(myBrowser,convertLookupWord(myBrowser,
			            word.getAttribute("label")));
	            } 
	        }
	        else {
                    if (myBrowser.webNavigation.canGoForward) {
	                myBrowser.webNavigation.goForward()
	            };
	        }
	    }
        } catch (e) { myDump ( myBrowser.getAttribute("homepage"));}   
    }

    midBackCounter++;
    midForwardCounter--;
    midupdateImages();

    }

}

function midhistBack()
{
    var myBrowser, word, home;
    if ( midBackCounter > -1 ){

    for(i=0; (myBrowser=document.getElementsByTagName("browser").item(i));i++){
        try {
           if (myBrowser.getAttribute("id") != "mid_MainBrowser") {
	       if (myBrowser.xmlDic.getAttribute("method")=="POST") {
	           if (midBackCounter==0) {
		       myBrowser.goHome();
		    } else {
	  	          word = document.getElementsByTagName("treecell").item((midBackCounter-1)*2);
                          midPostURI(myBrowser, 
		          convertLookupWord(myBrowser, word.getAttribute("label")));
		    }
	        } else {
                   if (myBrowser.webNavigation.canGoBack) { myBrowser.webNavigation.goBack() }
                }
	    }
        } catch (e) { myDump ( myBrowser.getAttribute("homepage") ) ;}   
    }	

    midForwardCounter++;
    midBackCounter--;
    midupdateImages();

    }

}



function midmainBrowserBack()
{
    var mid_mb=document.getElementById("mid_MainBrowser");
    mid_mb.goBack();  
}



function midmainBrowserForward()
{ 

    var mid_mb=document.getElementById("mid_MainBrowser");
    mid_mb.goForward();  
}


function midthisBrowserBack()
{

    var myTabPanel=domHelper.tabpanelsElement;
    myTabPanel.selectedPanel.goBack();  

}



function midthisBrowserForward()
{

    var myTabPanel=domHelper.tabpanelsElement;
    myTabPanel.selectedPanel.goForward();  

}



function midupdateImages()
{
    var b=document.getElementById("back_image");
    var f=document.getElementById("for_image");
    if ( midForwardCounter < 1 )
	   {f.setAttribute("canwalk","false")}
    else 
	   {f.setAttribute("canwalk","true")};
    if ( midBackCounter < 0 ) 
	   {b.setAttribute("canwalk","false")}
    else 
	   {b.setAttribute("canwalk","true")};
}



function midHistView()
{

    var wordsTree=document.getElementById("mid_wordstree");

    if (wordsTree.getAttribute("collapsed")=="true" ){
        document.getElementById("mid_viewpopuphistitem").setAttribute("checked","true");
        wordsTree.setAttribute("collapsed","false" );
    } else {
        document.getElementById("mid_viewpopuphistitem").setAttribute("checked","false");
        wordsTree.setAttribute("collapsed","true" );
    };

}



function midBrowserView()
{
    var midBrSp=document.getElementById("mid_BrowserSplitter");
    var midBr=document.getElementById("mid_BrowserBox");
    if (midBr.getAttribute("collapsed")=="true" ) {
        document.getElementById("mid_viewpopupbrowseritem").setAttribute("checked","true");
        midBr.setAttribute("collapsed","false" );
        midBrSp.setAttribute("collapsed","false" );
    } else {
        document.getElementById("mid_viewpopupbrowseritem").setAttribute("checked","false");
        midBr.setAttribute("collapsed","true" );
        midBrSp.setAttribute("collapsed","true" );
    };

}



function midBrowserNavigate()
{

    var midUrl=document.getElementById("mid_Url").value;
    var regexp= /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;
    var ar = regexp.exec(midUrl);
    // alert ( ar[0] + "-"  +  ar[1] + "-"  +  ar[2] + "-" ); 

    if ( ! ar[1] ) midUrl="http://" + midUrl;

    document.getElementById("mid_MainBrowser").setAttribute("src", midUrl );

}





function midunload(){

    if (dictionary=="default") saveDefaultSet(); 
    // do you want to save??
    removeEventListener('load',midMyOnLoad,true);
    // save selected later...
    removeEventListener("focus",checkFocusedElement,true);
    removeEventListener("click",checkClickedElement,true);
    removeEventListener("keyup",checkKeypressElement,true);
}



function midBrowserFullScreen()
{

    window.fullScreen=!window.fullScreen;

    document.getElementById("mid_viewFullScreen").setAttribute("checked",window.fullScreen);

    for(i=0; (midmyelement=document.getElementsByTagName("toolbar").item(i));i++){
       midmyelement.setAttribute("collapsed", window.fullScreen);
    }

    for(i=0; (midmyelement=document.getElementsByTagName("statusbar").item(i));i++){
       midmyelement.setAttribute("collapsed", window.fullScreen);
    }

    for(i=0; (midmyelement=document.getElementsByTagName("menubar").item(i));i++){
        midmyelement.setAttribute("collapsed", window.fullScreen);
    } 
   
}



function midSaveSession()
{
    var nsIFilePicker = Ci.nsIFilePicker;
    var nsIFileChannel = Ci.nsIFileChannel;
   
    var file = null, fileStream=null; 
   
    var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
    fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modeSave);
    fp.appendFilters(nsIFilePicker.filterAll);

    if (fp.show() == nsIFilePicker.returnCancel) { return false;}
       file = fp.file;

    fileStream =
    Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
   
    try {   
        fileStream.init( file, 0x04 | 0x08| 0x20, 420, 0 );
    } catch(e) {
        if ( e.name == "NS_ERROR_FILE_ACCESS_DENIED" ) localAlert("file.access.denied","");
        else alert("i/o error: " + e.name + "-" + e.message);   
	return false;
    } 
  
    var i,tb,a2,word,dictId;
   
    for (i=0; ( tb = document.getElementsByTagName("tab").item(i));i++){
        if (tb.getAttribute("collapsed")==false){
            dictId=tb.id.replace(/^tab/,"") + ";"+ tb.label;
            fileStream.write(dictId + "\n", dictId.length+1 );
        }
    };
   
    fileStream.close();

    //midMyPrefB.setComplexValue( "extensions.mid.lastusedsets.1", 
    //				Ci.nsILocalFile,
    //				file );
  
    if (typeof(arrangeLUFPrefs) == 'function') 
                arrangeLUFPrefs(file);


    localAlert("file.saved",""); 
    dictionary=getDictionaryFilename();
}



function midRestoreSession(filePrefNum,filename)
{
    var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
               createInstance(Ci.nsIScriptableUnicodeConverter);
    conv.charset = "UTF-8"
    
    var def;
    var nsIFilePicker = Ci.nsIFilePicker;
    var nsIFileChannel = Ci.nsIFileChannel;
   
    var file = null, fileStream=null; 
    if (  typeof(filePrefNum) != 'number' ) {
        var fp = Cc["@mozilla.org/filepicker;1"].createInstance (nsIFilePicker);
        fp.init (window, getLocaleString("choose.file"), nsIFilePicker.modeRead);
        fp.appendFilters(nsIFilePicker.filterAll);
        if (fp.show() == nsIFilePicker.returnCancel) { return false;}
        file = fp.file;
	var filename = ""; 
    } else {
        var savedFilesPrefs = midMyPrefS.getBranch("extensions.mid.lastusedsets.");
        if (!savedFilesPrefs.prefHasUserValue(filePrefNum)) {
	    localAlert("preference.not.found" , "extensions.mid.lastusedsets." + filePrefNum);
	    return false;
	};
	file = savedFilesPrefs.getComplexValue( filePrefNum, Ci.nsILocalFile);
	if (!file.exists()) { localAlert("file.not.found","");  return false; } 
    }
      
    var is =
    Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
  
    try {   
        is.init( file, 1 , 0444 , false  );  
    } catch(e) {
        if ( e.name == "NS_ERROR_FILE_ACCESS_DENIED" ) localAlert("file.access.denied","");
        else alert("i/o error: " + e.name + "-" + e.message);   
	return false;
    } 

    is.QueryInterface(Ci.nsILineInputStream);
    
    // read lines into array
    var midline = {}, midlines = [], hasmore;

    do {
      hasmore = is.readLine(midline)
      def=midline.value.replace(/;.*$/,""); 
      def=def.replace(/(.{37}).*/,"$1") // uuid
      midlines.push(def);
      } while(hasmore);

    is.close();

    if (typeof(arrangeLUFPrefs) == 'function') 
            arrangeLUFPrefs(file);

    if (filename == "" ) filename = getDictionaryFilename();
    midFromRestore=true;   // not used
    loadDictionaries(midlines);
    dictionary=filename;
}



function midremoveAllPreferences()
{

   branch = midMyPrefS.getBranch("extensions.mid.");
   branch.deleteBranch("");
   removeDefaultSet();
   // localAlert("application.restart","");
   //var deftype=
   //document.getElementsByTagName("default-dict-type").item(0).getAttribute("label");
   //if (midMyPrefB.getPrefType("extensions.mid.dtype."+ deftype) != midMyPrefB.PREF_BOOL){
   //   midMyPrefB.setBoolPref("extensions.mid.dtype." + deftype, true) ;
   //}

   var popup = document.getElementById("mid_lastusedfilespopup");
   while (popup.childNodes.length>1) popup.removeChild(popup.lastChild);

   loadDictionaries();

}



function localAlert(p,q)
{

  var msbd=document.getElementById(p);
  var ls=msbd.getString(p);
  alert(ls+q);

}



function getLocaleString(lsName)
{

    var  myprop =
    Cc["@mozilla.org/intl/stringbundle;1"].getService(Ci.nsIStringBundleService);

    var mystrings = myprop.createBundle("chrome://mid/locale/mid.properties");
    return  mystrings.GetStringFromName(lsName);

}



function midPostURI(browser, word)
{

    var dataString = browser.xmlDic.getAttribute("inputs").replace("XXX",word);

    var postData = Cc["@mozilla.org/network/mime-input-stream;1"].
        	       createInstance(Ci.nsIMIMEInputStream);

    var stringStream = Cc["@mozilla.org/io/string-input-stream;1"].
	                   createInstance(Ci.nsIStringInputStream);

    stringStream.setData(dataString,-1);
    postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
    postData.addContentLength = true;
    postData.setData(stringStream);

    var url=browser.xmlDic.getAttribute("url");

    browser.webNavigation.loadURI(url,
			 browser.webNavigation.LOAD_FLAGS_NONE,
	                 browser.currentURI ,
			 postData,null);

}



function midFindStringOnPage()
{

    var keres = top.document.getElementById("mid_searchWord").value;
   
    if (document.commandDispatcher.focusedWindow.name=="mid_MainBrowser") {
        if (keres != "") {
            if (! document.commandDispatcher.focusedWindow.find(keres))	
                while ( document.commandDispatcher.focusedWindow.find(keres,
	               	false, true)) 
	        continue;
        }
	return;
    }

    if ( document.getElementById("mid_tabbox") && 
        document.getElementById("mid_tabbox").selectedPanel ) {
        document.getElementById("mid_tabbox").selectedPanel.contentWindow.focus();
	if ( keres != "") {
            if (! document.commandDispatcher.focusedWindow.find(keres))	
                while ( document.commandDispatcher.focusedWindow.find(keres,
	     		false,true))
	        continue;
        }
   }

}



function midFindInNextPage(searchFlag){

    var ti=0, tabbox, op, oo , i;

    if ( document.getElementById("mid_tabbox") && 
        document.getElementById("mid_tabbox").selectedPanel ) {

	tabbox = document.getElementById("mid_tabbox");
	
	op = tabbox.selectedPanel;
        oo = op;
	while ( op ){
	  op = op.nextSibling;
	  if ( ! op ) { 
	     op = tabbox._tabpanels.childNodes.item(0);
	     tabbox.selectedIndex=0
	  } else tabbox.selectedIndex++;	
	  
	  if ( op &&  ( op.id == oo.id ) )  break ;  
	  if ( op && op.collapsed==false )  break ;

	}
	if (searchFlag) midFindInPage();
    }
}



function midFindInPrevPage(searchFlag)
{
    
    var ti=0, tabbox, op, oo , i;
    
    if ( document.getElementById("mid_tabbox") && 
        document.getElementById("mid_tabbox").selectedPanel ) {

	tabbox = document.getElementById("mid_tabbox");
	ti=tabbox._tabpanels.childNodes.length-1;
	
	op = tabbox.selectedPanel;
        oo = op;
	while ( op ){
	  op = op.previousSibling;
	  if ( ! op ) { 
	     op = tabbox._tabpanels.childNodes.item(ti);
	     tabbox.selectedIndex=ti;
	  } else tabbox.selectedIndex--;	
	  if ( op && op.id == oo.id  )  break ;  
	  if ( op && op.collapsed==false )  break ;
	}
	if (searchFlag) midFindInPage();
    }

}



function midFindInPage()
{

    var keres = top.document.getElementById("mid_searchWord").value;
    if ( document.getElementById("mid_tabbox") && 
        document.getElementById("mid_tabbox").selectedPanel ) {
        document.getElementById("mid_tabbox").selectedPanel.contentWindow.focus();
	if ( keres != "") {
           while ( document.commandDispatcher.focusedWindow.find(keres,false,true)) continue;
           // document.commandDispatcher.focusedWindow.find(keres);
        }
	// input mezo? akkor tovbb
	var theItem=document.commandDispatcher.focusedWindow.getSelection();
	if (  theItem == "" ) 
          document.commandDispatcher.focusedWindow.find(keres);	
   }

}



function styleTabs(event)
{

    var cButton=event.originalTarget;
    if (cButton.localName != "toolbarbutton") return ; // elsewere on tabs

    var curtab, curpanel, i;
    var mytabs = domHelper.tabsElement;

    for( i = 0; ( curtab = mytabs.getElementsByTagName("tab").item(i) ); i++ ){ 

       curpanel = document.getElementById(curtab.linkedpanel);

       if ( tabIconic ) { 
	  curtab.setAttribute("iconic", "false") }
       else  { 
	  curtab.setAttribute("iconic", "true");
       }
    }
    
    if (tabIconic) cButton.setAttribute("iconic", "false")
    else  cButton.setAttribute("iconic", "true");

    tabIconic = !tabIconic ; 

}


function saveDefaultSet()
{
    var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties)
	     .get("ProfD", Components.interfaces.nsIFile); 
    file.append("mid_default.dis");

    var  fileStream =
    Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
   
    fileStream.init( file, 0x02 | 0x08| 0x20, 0666, 0 );
   
    var i,tb,tabId;
   
    for (i=0; (tb=document.getElementsByTagName("tab").item(i));i++){
         tabId=tb.id.replace(/^tab/,"") + ";"+ tb.label;
         fileStream.write(tabId + "\n", tabId.length+1 );
    };
    fileStream.close();

}

function removeDefaultSet()
{
    var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties)
	     .get("ProfD", Components.interfaces.nsIFile); 
    file.append("mid_default.dis");
    
    try {
       if (file.exists()) file.remove(false);
    } catch(e) {
        if ( e.name == "NS_ERROR_FILE_ACCESS_DENIED" ) localAlert("file.access.denied","");
        else alert("i/o error: " + e.name + "-" + e.message);   
	return false;
    }
}




function restoreDefaultSet()
{
    var file = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties)
	     .get("ProfD", Components.interfaces.nsIFile); 
    file.append("mid_default.dis");
   
    if (!file.exists()) { loadDictionaries(); return false; } 

    var is =
    Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
  
    try {   
        is.init( file, 1 , 0444 , false  );  
    } catch(e) {
        if ( e.name == "NS_ERROR_FILE_ACCESS_DENIED" ) localAlert("file.access.denied","");
        else alert("i/o error: " + e.name + "-" + e.message);   
	return false;
    } 
    is.QueryInterface(Ci.nsILineInputStream);
    // read lines into array
    var midline = {}, midlines = [], hasmore;

    do {
      hasmore = is.readLine(midline)
      var dictId=midline.value.replace(/;.*$/,""); 
      dictId=dictId.replace(/(.{37}).*/,"$1") // uuid
      midlines.push(dictId);
      } while(hasmore);

    is.close();

    midFromRestore=true;   // not used
    loadDictionaries(midlines);
    dictionary="default";
    return true;
}




function myDump(aMessage) {
/*
*  http://kb.mozillazine.org/JavaScript_Console#Logging_custom_messages_in_JavaScript_Console
*/

   var consoleService = Cc["@mozilla.org/consoleservice;1"]
                         .getService(Ci.nsIConsoleService);
   consoleService.logStringMessage("mid_ " + aMessage);
}


function getDictionaryFilename()
{

    var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
            createInstance(Ci.nsIScriptableUnicodeConverter);
    conv.charset = "UTF-8"

    var savedFilesPrefs = midMyPrefS.getBranch("extensions.mid.lastusedsets.");
    if (savedFilesPrefs.prefHasUserValue(1))
        return conv.ConvertToUnicode(savedFilesPrefs.getCharPref(1));
    return "Unknown";

}
